"""Tar interface using Popen

This module provides simple methods to create and extract tar balls

Author: Thomas Low <thomas.low@cern.ch>
"""

import popen2, os.path

def create(path, filelist):
	_runCommand("tar -cf %s %s" % (path, " ".join(filelist)), "")
	
def extract(path, directory="."):
	path = os.path.abspath(path)
	directory = os.path.abspath(directory)
	_runCommand("cd %s && tar -xf %s" % (directory, path), "")
	
def _runCommand(cmd, data):
	p = popen2.Popen3(cmd, 1)
	p.tochild.write(data)
	p.tochild.close()
	tmp = p.fromchild.readlines()
	p.fromchild.close()
	err = p.childerr.readlines()
	p.childerr.close()
	if err:
		raise Exception("".join(err))
	p.wait()
	return ''.join(tmp)
