"""Test Consumer

This module provides an abstract class for a Test-Consumer.

Author: Thomas Low <thomas.low@cern.ch>
"""

class TestConsumer:
	"""This module abstracts a TestConsumer class.
	
	Hopefully this will make it easier to write new ones."""
	
	def __init__(self, **kw):
		"""The init-methode will be called with some key-value arguments.
		
		(They will usually be loaded from the configuration file)"""

	def setup(self):
		"""Will be called before any test can be consumed."""
		pass
		
	def consume(self, test):
		"""Will be called with a test."""
		raise NotImplementedError("Subclass has to overwrite this!")
		
	def cleanup(self):
		"""Will be called after no test can be consumed anymore."""
		pass
		
	def __str__(self):
		return "<"+self.__class__.__name__+">"
