"""Test Producer

This module provides an abstract class for a Test-Producer.

Author: Thomas Low <thomas.low@cern.ch>
"""

class TestProducer:
	"""An abstract Class for a Producer of Test classes.
	
	This will hopefully help to create more producers easily."""
	
	def setup(self):
		"""Will be called before the run() methode."""
		pass
	
	def run(self, event):
		"""Will be called to create actual tests.
		
		Methode has to call event(test) to submit new test."""
		raise NotImplementedError("Subclass has to overwrite this!")
		
	def cleanup(self):
		"""Will be called after the run() methode."""
		pass
	
	def __str__(self):
		return "<"+self.__class__.__name__+">"
