import re, logging

log = logging.getLogger('pyamq.lib.util')

pattern = re.compile(r"((\S+)://)?([^:/\?]+)(:([0-9]+))?(/[^\?&]*)?(\?([^ ]*))?")

def getUrlsAsDicts(broker):
	l = []
	for url in broker:
		try:
			d = getUrlAsDict(url)
			l.append(d)
		except Exception, err:
			log.exception(err)
	return l

def getUrlAsDict(url):
	"""Converts a list of urls into a list of dictionaris.""" 
	_,scheme,host,_,port,path,_,args = pattern.match(url).groups()
	d = {}
	d['protocol'] = scheme
	d['host'] = host
	d['port'] = port
	d['path'] = path
	if args:
		arglist = args.split("&")
		for arg in arglist:
			kv = arg.split("=")
			if len(kv) > 1:
				d[kv[0]] = kv[1]
	
	return d
